Index: /LMDZ4/trunk/libf/phylmd/phytrac.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/phytrac.F	(revision 540)
+++ /LMDZ4/trunk/libf/phylmd/phytrac.F	(revision 541)
@@ -23,4 +23,5 @@
      I                    pde_d,
      I                    coefh,
+     I                    fm_therm,entr_therm,
      I                    yu1,
      I                    yv1,
@@ -130,5 +131,6 @@
       logical debutphy       ! le flag de l'initialisation de la physique
       logical lafin          ! le flag de la fin de la physique
-
+c Olivia      
+      integer isplit,nsplit
       REAL pmflxr(klon,klev+1), pmflxs(klon,klev+1)   !--lessivage convection
       REAL prfl(klon,klev+1),   psfl(klon,klev+1)     !--lessivage large-scale
@@ -146,4 +148,12 @@
       REAL pmfd(nlon,nlev)  ! flux de masse dans le panache descendant
       REAL pen_u(nlon,nlev) ! flux entraine dans le panache montant
+
+c
+c   thermiques:
+c   -----------
+c
+      real fm_therm(klon,klev+1),entr_therm(klon,klev)
+	real fm_therm1(klon,klev)
+c
       REAL pde_u(nlon,nlev) ! flux detraine dans le panache montant
       REAL pen_d(nlon,nlev) ! flux entraine dans le panache descendant
@@ -265,5 +275,8 @@
       REAL d_tr(klon,klev), d_trs(klon) ! tendances de traceurs 
       REAL d_tr_cl(klon,klev) ! tendance de traceurs  couche limite
-      REAL d_tr_cv(klon,klev) ! tendance de traceurs  convection 
+      REAL d_tr_cli(klon,klev,nbtr) ! tendance de traceurs  CL pour chq traceur
+      REAL d_tr_cv(klon,klev) ! tendance de traceurs  convection
+      REAL d_tr_cvi(klon,klev,nbtr) ! tendance de traceurs  conv pour chq traceur
+      REAL d_tr_th(klon,klev,nbtr) ! la tendance des thermiques
       REAL d_tr_dec(klon,klev,nbtr) ! la tendance de la decroissance 
 c                                   ! radioactive du rn - > pb 
@@ -280,4 +293,6 @@
       REAL flestottr(klon,klev,nbtr) ! flux de lessivage 
 c                                    ! dans chaque couche 
+      real zmasse(klon,klev)
+      real ztra_th(klon,klev)
 
 C
@@ -288,9 +303,14 @@
 c-------------
       logical first,couchelimite,convection,lessivage,sorties,
-     s        rnpb,inirnpb
-      save first,couchelimite,convection,lessivage,sorties,
-     s     inirnpb
-      data first,couchelimite,convection,lessivage,sorties
-     s     /.true.,.true.,.false.,.true.,.true./
+     s        rnpb,inirnpb,thermiques
+      save first,couchelimite,convection,lessivage,thermiques,
+     s        sorties,inirnpb
+c      data first,couchelimite,convection,lessivage,sorties
+c     s     /.true.,.true.,.false.,.true.,.true./
+c Olivia
+       data first,couchelimite,convection,lessivage,
+     s      thermiques,sorties
+     s     /.true.,.true.,.true.,.true.,.true.,.true./
+
 
 #ifdef INCA
@@ -522,4 +542,6 @@
       DO i = 1, klon
          tr_seri(i,k,it) = tr_seri(i,k,it) + d_tr_cv(i,k)
+	 d_tr_cvi(i,k,it)=d_tr_cv(i,k)
+c	 print*,'en k i d_tr_cv=',k,i,d_tr_cv(i,k)
       ENDDO
       ENDDO
@@ -541,4 +563,63 @@
 c      enddo
 
+
+c======================================================================
+c   Calcul de l'effet des thermiques
+c======================================================================
+
+      do k=1,klev
+         do i=1,klon
+            zmasse(i,k)=(paprs(i,k)-paprs(i,k+1))/rg
+         enddo
+      enddo
+
+c      print*,'masse dans ph ',zmasse
+      do it=1,nqmax
+         do k=1,klev
+            do i=1,klon
+               d_tr_th(i,k,it)=0.
+               tr_seri(i,k,it)=max(tr_seri(i,k,it),0.)
+               tr_seri(i,k,it)=min(tr_seri(i,k,it),1.e10)
+            enddo
+         enddo
+      enddo
+
+      if (thermiques) then
+        print*,'calcul de leffet des thermiques'
+        nsplit=10
+        DO it=1, nqmax
+c        WRITE(itn,'(i1)') it
+c        CALL minmaxqfi(tr_seri(1,1,it),1.e10,-1.e33,'conv it='//itn)
+c	     print*,'avant dqthermiquesretro'
+c             call dump2d(iim,jjm-1,tr_seri(2,1,1),'TR_SERI      ')
+
+         do isplit=1,nsplit
+c  Abderr 25 11 02
+C Thermiques 
+c	print*,'Avant dans phytrac',avant
+            call dqthermcell(klon,klev,pdtphys/nsplit
+     .       ,fm_therm,entr_therm,zmasse
+     .       ,tr_seri(1:klon,1:klev,it),d_tr,ztra_th)
+
+            do k=1,klev
+               do i=1,klon
+                  d_tr(i,k)=pdtphys*d_tr(i,k)/nsplit
+                  d_tr_th(i,k,it)=d_tr_th(i,k,it)+d_tr(i,k)
+                  tr_seri(i,k,it)=max(tr_seri(i,k,it)+d_tr(i,k),0.)
+               enddo
+            enddo
+          enddo ! nsplit
+          print*,'apres thermiques'
+c             call dump2d(iim,jjm-1,d_tr_th(1,1,1),'d_tr_th      ')
+c            do k=1,klev
+c	print*,'d_tr_th(',k,')=',tr_seri(280,k,1)
+c	   enddo
+
+c        WRITE(itn,'(i1)') it
+c        CALL minmaxqfi(tr_seri(1,1,it),1.e10,-1.e33,'therm it='//itn)
+       ENDDO ! it
+       endif ! Thermiques
+c       print*,'ATTENTION: sdans thermniques'
+      
 c======================================================================
 c   Calcul de l'effet de la couche limite
@@ -576,4 +657,5 @@
             DO i = 1, klon
               tr_seri(i,k,it) = tr_seri(i,k,it) + d_tr_cl(i,k)
+	      d_tr_cli(i,k,it)=d_tr_cl(i,k)
             ENDDO
           ENDDO
@@ -608,4 +690,5 @@
                DO i = 1, klon
                   tr_seri(i,k,it) = tr_seri(i,k,it) + d_tr(i,k)
+		  d_tr_cli(i,k,it)=d_tr_cl(i,k)
                ENDDO
             ENDDO
Index: /LMDZ4/trunk/libf/phylmd/read_pstoke.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/read_pstoke.F	(revision 540)
+++ /LMDZ4/trunk/libf/phylmd/read_pstoke.F	(revision 541)
@@ -7,5 +7,14 @@
      .   zrec,zklono,zklevo,airefi,phisfi,
      .   t,mfu,mfd,en_u,de_u,en_d,de_d,coefh,
+     .   fm_therm,en_therm,
      .   frac_impa,frac_nucl,pyu1,pyv1,ftsol,psrf)
+
+C******************************************************************************
+C  Frederic HOURDIN, Abderrahmane IDELKADI
+C Lecture des parametres physique stockes online necessaires pour
+C recalculer offline le transport de traceurs sur une grille 2x plus fine que 
+C celle online 
+C A FAIRE : une seule routine au lieu de 2 (lectflux, redecoupe)!
+C******************************************************************************
 
 
@@ -26,28 +35,31 @@
 #include "dimphy.h"
 	
-	  integer*4 klono,klevo,imo,jmo
+	  integer klono,klevo,imo,jmo
 	  parameter (imo=iim/2,jmo=(jjm+1)/2)
 	  parameter(klono=(jmo-1)*imo+2,klevo=llm)
-	  REAL*4 phisfi(klono)
-          REAL*4 phisfi2(imo,jmo+1),airefi2(imo,jmo+1)
-
-          REAL*4 mfu(klono,klevo), mfd(klono,klevo)
-          REAL*4 en_u(klono,klevo), de_u(klono,klevo)
-          REAL*4 en_d(klono,klevo), de_d(klono,klevo)
-          REAL*4 coefh(klono,klevo)
-
-          REAL*4 mfu2(imo,jmo+1,klevo), mfd2(imo,jmo+1,klevo)
-          REAL*4 en_u2(imo,jmo+1,klevo), de_u2(imo,jmo+1,klevo)
-          REAL*4 en_d2(imo,jmo+1,klevo), de_d2(imo,jmo+1,klevo)
-          REAL*4 coefh2(imo,jmo+1,klevo)
-
-          REAL*4 pl(klevo)
+	  REAL phisfi(klono)
+          REAL phisfi2(imo,jmo+1),airefi2(imo,jmo+1)
+
+          REAL mfu(klono,klevo), mfd(klono,klevo)
+          REAL en_u(klono,klevo), de_u(klono,klevo)
+          REAL en_d(klono,klevo), de_d(klono,klevo)
+          REAL coefh(klono,klevo)
+           REAL fm_therm(klono,klevo),en_therm(klono,klevo)
+
+          REAL mfu2(imo,jmo+1,klevo), mfd2(imo,jmo+1,klevo)
+          REAL en_u2(imo,jmo+1,klevo), de_u2(imo,jmo+1,klevo)
+          REAL en_d2(imo,jmo+1,klevo), de_d2(imo,jmo+1,klevo)
+          REAL coefh2(imo,jmo+1,klevo)
+           REAL fm_therm2(imo,jmo+1,klevo)
+           REAL en_therm2(imo,jmo+1,klevo)
+
+          REAL pl(klevo)
           integer irec
-          integer*4 xid,yid,zid,tid
+          integer xid,yid,zid,tid
           real zrec,zklono,zklevo,zim,zjm
-          integer*4 ncrec,ncklono,ncklevo,ncim,ncjm
-
-          real*4 airefi(klono)
-          character namedim
+          integer ncrec,ncklono,ncklevo,ncim,ncjm
+
+          real airefi(klono)
+          character*20 namedim
 
 c  !! attention !!
@@ -56,20 +68,20 @@
 	  
 	 
-          REAL*4 frac_impa(klono,klevo), frac_nucl(klono,klevo)
-          REAL*4 frac_impa2(imo,jmo+1,klevo), 
+          REAL frac_impa(klono,klevo), frac_nucl(klono,klevo)
+          REAL frac_impa2(imo,jmo+1,klevo), 
      .     frac_nucl2(imo,jmo+1,klevo)
-          REAL*4 pyu1(klono), pyv1(klono)
-          REAL*4 pyu12(imo,jmo+1), pyv12(imo,jmo+1)
-          REAL*4 ftsol(klono,nbsrf)
-          REAL*4 psrf(klono,nbsrf) 
-	  REAL*4 ftsol1(klono),ftsol2(klono),ftsol3(klono),ftsol4(klono)
-          REAL*4 psrf1(klono),psrf2(klono),psrf3(klono),psrf4(klono)
-          REAL*4 ftsol12(imo,jmo+1),ftsol22(imo,jmo+1),
+          REAL pyu1(klono), pyv1(klono)
+          REAL pyu12(imo,jmo+1), pyv12(imo,jmo+1)
+          REAL ftsol(klono,nbsrf)
+          REAL psrf(klono,nbsrf) 
+	  REAL ftsol1(klono),ftsol2(klono),ftsol3(klono),ftsol4(klono)
+          REAL psrf1(klono),psrf2(klono),psrf3(klono),psrf4(klono)
+          REAL ftsol12(imo,jmo+1),ftsol22(imo,jmo+1),
      .     ftsol32(imo,jmo+1),
      .     ftsol42(imo,jmo+1)
-          REAL*4 psrf12(imo,jmo+1),psrf22(imo,jmo+1),psrf32(imo,jmo+1),
+          REAL psrf12(imo,jmo+1),psrf22(imo,jmo+1),psrf32(imo,jmo+1),
      .     psrf42(imo,jmo+1)
-		REAL*4 t(klono,klevo)
-		REAL*4 t2(imo,jmo+1)	
+		REAL t(klono,klevo)
+		REAL t2(imo,jmo+1,klevo)	
 	  integer ncidp
           save ncidp
@@ -77,4 +89,5 @@
           integer varidmfu, varidmfd, varidps, varidenu, variddeu	
           integer varidend,varidded,varidch,varidfi,varidfn
+           integer varidfmth,varidenth
           integer varidyu1,varidyv1,varidpl,varidai,varididvt
           integer varidfts1,varidfts2,varidfts3,varidfts4
@@ -82,4 +95,5 @@
           save varidmfu, varidmfd, varidps, varidenu, variddeu
           save varidend,varidded,varidch,varidfi,varidfn
+           save varidfmth,varidenth
           save varidyu1,varidyv1,varidpl,varidai,varididvt
           save varidfts1,varidfts2,varidfts3,varidfts4
@@ -113,6 +127,8 @@
             print*,'ncidp,varidai',ncidp,varidai
 
+c A FAIRE: Es-il necessaire de stocke t?
 	        varidt=NCVID(ncidp,'t',rcode)
                 print*,'ncidp,varidt',ncidp,varidt
+
             varidmfu=NCVID(ncidp,'mfu',rcode)
             print*,'ncidp,varidmfu',ncidp,varidmfu
@@ -136,4 +152,11 @@
             print*,'ncidp,varidch',ncidp,varidch
 	
+c abder (pour thermiques)
+             varidfmth=NCVID(ncidp,'fm_th',rcode)
+             print*,'ncidp,varidfmth',ncidp,varidfmth
+
+             varidenth=NCVID(ncidp,'en_th',rcode)
+             print*,'ncidp,varidenth',ncidp,varidenth
+
 	    varidfi=NCVID(ncidp,'frac_impa',rcode)
             print*,'ncidp,varidfi',ncidp,varidfi
@@ -200,6 +223,9 @@
 
 c niveaux de pression
-
-            status=NF_GET_VARA_REAL(ncidp,varidpl,1,zklevo,pl)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidpl,1,zklevo,pl)
+#else
+      status=NF_GET_VARA_REAL(ncidp,varidpl,1,zklevo,pl)
+#endif
 
 c lecture de aire et phis
@@ -216,15 +242,17 @@
 
 c phis
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidps,start,count,phisfi2)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidps,start,count,phisfi2)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*1,phisfi2)
-c      call dump2d(iip1-1,jjp1,phisfi2,'PHISNC')
+#endif
       call gr_ecrit_fi(1,klono,imo,jmo+1,phisfi2,phisfi)
 
 c aire
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidai,start,count,airefi2)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidai,start,count,airefi2)
-c      call correctbid(iim,jjp1*1,airefi2)
-c       call dump2d(iip1-1,jjp1,airefi2,'AIRENC')
+#endif
        call gr_ecrit_fi(1,klono,imo,jmo+1,airefi2,airefi)
       else
@@ -249,165 +277,190 @@
       count(4)=1
 
+
+C *** Lessivage******************************************************
 c frac_impa 
-
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfi,start,count,frac_impa2)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidfi,start,count,frac_impa2)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*klevo,frac_impa2)
-c      call dump2d(iip1-1,jjp1,frac_impa2,'FINC COUCHE 1')
+#endif
       call gr_ecrit_fi(klevo,klono,imo,jmo+1,frac_impa2,frac_impa)
 
 c frac_nucl 
-
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfn,start,count,frac_nucl2)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidfn,start,count,frac_nucl2)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*klevo,frac_nucl2)
-c      call dump2d(iip1-1,jjp1,frac_nucl2,'FINC COUCHE 1')
+#endif
       call gr_ecrit_fi(klevo,klono,imo,jmo+1,frac_nucl2,frac_nucl)
 
+C*** Temperature ******************************************************
 c abder t
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidt,start,count,t2)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidt,start,count,t2)
+#endif
       call gr_ecrit_fi(klevo,klono,imo,jmo+1,t2,t)
 
+C*** Flux pour le calcul de la convection TIEDTK ***********************
 c mfu
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidmfu,start,count,mfu2)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidmfu,start,count,mfu2)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*klevo,mfu2)
-c      call dump2d(iip1-1,jjp1,mfu2,'MFUNC COUCHE 1')
+#endif
       call gr_ecrit_fi(klevo,klono,imo,jmo+1,mfu2,mfu)
 
 c mfd
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidmfd,start,count,mfd2)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidmfd,start,count,mfd2)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*klevo,mfd2)
-c      call dump2d(iip1-1,jjp1,mfd2,'MFDNC COUCHE 1')
+#endif
       call gr_ecrit_fi(klevo,klono,imo,jmo+1,mfd2,mfd)
 
 c en_u 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidenu,start,count,en_u2)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidenu,start,count,en_u2)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*klevo,en_u2)
-c      call dump2d(iip1-1,jjp1,en_u2,'ENUNC COUCHE 1')
+#endif
       call gr_ecrit_fi(klevo,klono,imo,jmo+1,en_u2,en_u)
 
 c de_u 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,variddeu,start,count,de_u2)
+#else
       status=NF_GET_VARA_REAL(ncidp,variddeu,start,count,de_u2)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*klevo,de_u2)
-c      call dump2d(iip1-1,jjp1,de_u2,'DEUNC COUCHE 1')
+#endif
       call gr_ecrit_fi(klevo,klono,imo,jmo+1,de_u2,de_u)
 
 c en_d 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidend,start,count,en_d2)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidend,start,count,en_d2)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*klevo,en_d2)
-c      call dump2d(iip1-1,jjp1,en_d2,'ENDNC COUCHE 1')
+#endif
       call gr_ecrit_fi(klevo,klono,imo,jmo+1,en_d2,en_d)
 
 c de_d 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidded,start,count,de_d2)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidded,start,count,de_d2)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*klevo,de_d2)
-c      call dump2d(iip1-1,jjp1,de_d2,'DEDNC COUCHE 1')
+#endif
       call gr_ecrit_fi(klevo,klono,imo,jmo+1,de_d2,de_d)
 
+C **** Coeffecient du mellange turbulent**********************************
 c coefh 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidch,start,count,coefh2)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidch,start,count,coefh2)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*klevo,coefh2)
-c      call dump2d(iip1-1,jjp1,coefh2,'CHNC COUCHE 1')
+#endif
        call gr_ecrit_fi(klevo,klono,imo,jmo+1,coefh2,coefh)
 
+C*** Flux ascendant et entrant pour les Thermiques************************
+cabder thermiques
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfmth,start,count,fm_therm2)
+#else
+      status=NF_GET_VARA_REAL(ncidp,varidfmth,start,count,fm_therm2)
+#endif
+      call gr_ecrit_fi(klevo,klono,imo,jmo+1,fm_therm2,fm_therm)
+
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidenth,start,count,en_therm2)
+#else
+      status=NF_GET_VARA_REAL(ncidp,varidenth,start,count,en_therm2)
+#endif
+      call gr_ecrit_fi(klevo,klono,imo,jmo+1,en_therm2,en_therm)
+
+C*** Vitesses aux sol ******************************************************
       start(3)=irec
       start(4)=0
       count(3)=1
       count(4)=0
-
 c pyu1
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidyu1,start,count,pyu12)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidyu1,start,count,pyu12)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*1,pyu12)
-c      call dump2d(iip1-1,jjp1,pyu12,'PYU1NC')
+#endif
       call gr_ecrit_fi(1,klono,imo,jmo+1,pyu12,pyu1)
 
 c pyv1
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidyv1,start,count,pyv12)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidyv1,start,count,pyv12)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*1,pyv12)
-c      call dump2d(iip1-1,jjp1,pyv12,'PYV1NC')
+#endif
       call gr_ecrit_fi(1,klono,imo,jmo+1,pyv12,pyv1)
 
+C*** Temperature au sol ********************************************
 c ftsol1
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfts1,start,count,ftsol12)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidfts1,start,count,ftsol12)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*1,ftsol12)
-c      call dump2d(iip1-1,jjp1,ftsol12,'FTS1NC')
+#endif
        call gr_ecrit_fi(1,klono,imo,jmo+1,ftsol12,ftsol1)
 
 c ftsol2
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfts2,start,count,ftsol22)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidfts2,start,count,ftsol22)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*1,ftsol22)
-c      call dump2d(iip1-1,jjp1,ftsol22,'FTS2NC')
+#endif
       call gr_ecrit_fi(1,klono,imo,jmo+1,ftsol22,ftsol2)
 
 c ftsol3
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfts3,start,count,ftsol32)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidfts3,start,count,ftsol32)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*1,ftsol32)
-c      call dump2d(iip1-1,jjp1,ftsol32,'FTS3NC')
+#endif
       call gr_ecrit_fi(1,klono,imo,jmo+1,ftsol32,ftsol3)
 
 c ftsol4
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfts4,start,count,ftsol42)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidfts4,start,count,ftsol42)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*1,ftsol42)
-c      call dump2d(iip1-1,jjp1,ftsol42,'FTS4NC')
+#endif
       call gr_ecrit_fi(1,klono,imo,jmo+1,ftsol42,ftsol4)
 
+C*** Nature du sol **************************************************
 c psrf1 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidpsr1,start,count,psrf12)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidpsr1,start,count,psrf12)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*1,psrf12)
-c      call dump2d(iip1-1,jjp1,psrf12,'PSRF1NC')
+#endif
       call gr_ecrit_fi(1,klono,imo,jmo+1,psrf12,psrf1)
 
 c psrf2 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidpsr2,start,count,psrf22)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidpsr2,start,count,psrf22)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*1,psrf22)
-c      call dump2d(iip1-1,jjp1,psrf22,'PSRF2NC')
+#endif
       call gr_ecrit_fi(1,klono,imo,jmo+1,psrf22,psrf2)
 
 c psrf3 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidpsr3,start,count,psrf32)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidpsr3,start,count,psrf32)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*1,psrf32)
-c      call dump2d(iip1-1,jjp1,psrf32,'PSRF3NC')
+#endif
       call gr_ecrit_fi(1,klono,imo,jmo+1,psrf32,psrf3)
 
 c psrf4 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidpsr4,start,count,psrf42)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidpsr4,start,count,psrf42)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*1,psrf42)
-c      call dump2d(iip1-1,jjp1,psrf42,'PSRF4NC')
+#endif
       call gr_ecrit_fi(1,klono,imo,jmo+1,psrf42,psrf4)
 	
